package RACTest;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import RAContainer.*;


public class Frame1 extends JFrame
{
  BorderLayout borderLayout1 = new BorderLayout();
  JButton retrieveBtn = new JButton();
  JTextField inputTF = new JTextField();
  JButton storeBtn = new JButton();
  JTextArea outputTA = new JTextArea();

  ButtonGroup buttonGroup = new ButtonGroup();

  //Construct the frame
  public Frame1()
  {
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	try
	{
	  jbInit();
	}
	catch(Exception e)
	{
	  e.printStackTrace();
	}
	buttonGroup.add(stackRB);
	buttonGroup.add(queueRB);
	buttonGroup.add(orderedIntRB);
        outputTA.setVisible(false);
  }

  //Component initialization
  private void jbInit() throws Exception
  {
	retrieveBtn.setFont(new java.awt.Font("Dialog", 0, 30));
    retrieveBtn.setText("Retrieve");
	retrieveBtn.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		retrieveBtn_actionPerformed(e);
	  }
	});
	this.getContentPane().setLayout(borderLayout1);
	this.setSize(new Dimension(763, 427));
	this.setTitle("Frame Title");
	inputTF.setFont(new java.awt.Font("SansSerif", 1, 50));
    inputTF.setText("0");
	inputTF.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		inputTF_actionPerformed(e);
	  }
	});
	storeBtn.setFont(new java.awt.Font("Dialog", 0, 30));
    storeBtn.setText("Store");
	storeBtn.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		storeBtn_actionPerformed(e);
	  }
	});
	outputLabel.setFont(new java.awt.Font("Dialog", 1, 50));
    outputLabel.setText(" ");
	jPanel1.setLayout(gridLayout1);
	gridLayout1.setColumns(1);
	gridLayout1.setRows(-1);
	stackRB.setSelected(true);
	stackRB.setText("Stack");
    stackRB.setFont(new java.awt.Font("Dialog", 0, 30));
	stackRB.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		stackRB_actionPerformed(e);
	  }
	});
	queueRB.setText("Queue");
    queueRB.setFont(new java.awt.Font("Dialog", 0, 30));
	queueRB.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		queueRB_actionPerformed(e);
	  }
	});
	jPanel2.setLayout(gridLayout2);
	gridLayout2.setColumns(1);
	gridLayout2.setRows(-1);
	orderedIntRB.setText("Ordered Integer");
    orderedIntRB.setFont(new java.awt.Font("Dialog", 0, 30));
	orderedIntRB.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		orderedIntRB_actionPerformed(e);
	  }
	});
	clrBtn.setFont(new java.awt.Font("Dialog", 0, 30));
    clrBtn.setText("Clear");
	clrBtn.addActionListener(new java.awt.event.ActionListener()
	{

	  public void actionPerformed(ActionEvent e)
	  {
		clrBtn_actionPerformed(e);
	  }
	});
	showIntRBtn.setText("Show internals");
    showIntRBtn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        showIntRBtn_actionPerformed(e);
      }
    });
    hideIntRBtn.setSelected(true);
    hideIntRBtn.setText("Hide internals");
    hideIntRBtn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        hideIntRBtn_actionPerformed(e);
      }
    });
    jPanel3.setLayout(gridLayout3);
    gridLayout3.setRows(-1);
    gridLayout3.setColumns(1);
    outputTA.setFont(new java.awt.Font("Dialog", 0, 50));
    this.getContentPane().add(outputTA, BorderLayout.CENTER);
	this.getContentPane().add(jPanel1, BorderLayout.WEST);
	jPanel1.add(storeBtn, null);
	jPanel1.add(retrieveBtn, null);
	jPanel1.add(clrBtn, null);
    jPanel1.add(jPanel3, null);
    jPanel3.add(showIntRBtn, null);
    jPanel3.add(hideIntRBtn, null);
	this.getContentPane().add(jPanel2, BorderLayout.EAST);
	jPanel2.add(stackRB, null);
	jPanel2.add(queueRB, null);
	jPanel2.add(orderedIntRB, null);
	this.getContentPane().add(outputLabel, BorderLayout.SOUTH);
	this.getContentPane().add(inputTF, BorderLayout.NORTH);
    buttonGroup1.add(hideIntRBtn);
    buttonGroup1.add(showIntRBtn);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
	super.processWindowEvent(e);
	if(e.getID() == WindowEvent.WINDOW_CLOSING)
	{
	  System.exit(0);
	}
  }

  RACont raCont = new RACont(new StackPolicy());
  JLabel outputLabel = new JLabel();
  JPanel jPanel1 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel2 = new JPanel();
  JRadioButton stackRB = new JRadioButton();
  JRadioButton queueRB = new JRadioButton();
  GridLayout gridLayout2 = new GridLayout();
  JRadioButton orderedIntRB = new JRadioButton();
  JButton clrBtn = new JButton();
  JPanel jPanel3 = new JPanel();
  JRadioButton showIntRBtn = new JRadioButton();
  JRadioButton hideIntRBtn = new JRadioButton();
  GridLayout gridLayout3 = new GridLayout();
  ButtonGroup buttonGroup1 = new ButtonGroup();

  void storeBtn_actionPerformed(ActionEvent e)
  {
	try
	{
	   raCont.store(new Integer(inputTF.getText()));
		printRACont(" ");
	}
	catch (Exception ex)
	{
		outputLabel.setText("Please type an integer!");
	}
	inputTF.setText("");
  }

  void retrieveBtn_actionPerformed(ActionEvent e)
  {
	Object tmp =raCont.retrieve();
	String tmpStr;
	if(null== tmp) tmpStr = "StopNode encountered! ";
	else tmpStr = tmp.toString();
	//tmpStr += "  Empty? " + raCont.isEmpty();
	   printRACont(tmpStr);

  }

  void stackRB_actionPerformed(ActionEvent e)
  {
	raCont.installPolicy(new StackPolicy());
		printRACont("StackPolicy installed.");
  }


  void printRACont(String s)
  {
	outputTA.setText(raCont.toString());
	outputLabel.setText(s);
  }

  void queueRB_actionPerformed(ActionEvent e)
  {
		raCont.installPolicy(new QueuePolicy());
		printRACont("QueuePolicy installed.");
  }

  void orderedIntRB_actionPerformed(ActionEvent e)
  {
		raCont.installPolicy(new OrderedIntegerPolicy());
		printRACont("OrderedIntegerPolicy installed ");
  }

  void inputTF_actionPerformed(ActionEvent e)
  {
	 storeBtn_actionPerformed(e);
  }

  void clrBtn_actionPerformed(ActionEvent e)
  {
	raCont.clear();
	printRACont(" ");
  }

  void hideIntRBtn_actionPerformed(ActionEvent e)
  {
    outputTA.setVisible(false);
  }

  void showIntRBtn_actionPerformed(ActionEvent e)
  {
    outputTA.setVisible(true);

  }

}
