
package RAContainer;

/**
 * The interface for the visitor design pattern algorithm for processing the internal doubly-linked circular list of the RACont.
 * 
 */
public interface IRACVisitor
{
	/**
	 * The method called when the RACStopNode is encountered. 
	 * @param host The RACStopNode that called this method.
	 * @param param The external parameter passed to this algorithm.
	 * @return The return value of this algorithm.
	 */
	public Object stopCase(RACStopNode host, Object param);

	/**
	 * The method called when the RACDataNode is encountered. 
	 * @param host The RACDataNode that called this method.
	 * @param param The external parameter passed to this algorithm.
	 * @return The return value of this algorithm.
	 */
	public Object dataCase(RACDataNode host, Object param);
}

